diff a/make/common/Modules.gmk b/make/common/Modules.gmk
--- a/make/common/Modules.gmk
+++ b/make/common/Modules.gmk
@@ -78,10 +78,14 @@
 
 GENERATED_SRC_DIRS += \
     $(SUPPORT_OUTPUTDIR)/gensrc \
     #
 
+GENERATED_VALUE_CLASS_SUBDIRS += \
+    $(SUPPORT_OUTPUTDIR)/gensrc-valueclasses \
+    #
+
 TOP_SRC_DIRS += \
     $(TOPDIR)/src \
     #
 
 SRC_SUBDIRS += $(OPENJDK_TARGET_OS)/classes
@@ -144,10 +148,16 @@
 FindModuleSrcDirs = \
     $(strip $(wildcard \
         $(addsuffix /$(strip $1), $(GENERATED_SRC_DIRS) $(IMPORT_MODULES_SRC)) \
         $(foreach sub, $(SRC_SUBDIRS), $(addsuffix /$(strip $1)/$(sub), $(TOP_SRC_DIRS)))))
 
+# Find value class source dirs for a particular module  (only generated)
+# $1 - Module to find source dirs for
+FindModuleValueClassSrcDirs = \
+    $(strip $(wildcard \
+        $(addsuffix /$(strip $1), $(GENERATED_VALUE_CLASS_SUBDIRS))))
+
 # Find all specs dirs for a particular module
 # $1 - Module to find specs dirs for
 FindModuleSpecsDirs = \
     $(strip $(wildcard \
         $(foreach sub, $(SPEC_SUBDIRS), $(addsuffix /$(strip $1)/$(sub), $(TOP_SRC_DIRS)))))
@@ -161,10 +171,16 @@
 # Construct the complete module source path
 GetModuleSrcPath = \
     $(call PathList, \
         $(addsuffix /*, $(GENERATED_SRC_DIRS) $(IMPORT_MODULES_SRC)) \
         $(foreach sub, $(SRC_SUBDIRS), $(addsuffix /*/$(sub), $(TOP_SRC_DIRS))))
+
+# Construct the complete module source path for value classes
+GetModuleValueClassSrcPath = \
+    $(call PathList, \
+        $(addsuffix /*, $(GENERATED_VALUE_CLASS_SUBDIRS) $(GENERATED_SRC_DIRS) $(IMPORT_MODULES_SRC)) \
+        $(foreach sub, $(SRC_SUBDIRS), $(addsuffix /*/$(sub), $(TOP_SRC_DIRS))))
 
 ################################################################################
 # Extract module dependencies from module-info.java files, both normal
 # dependencies ("requires"), and indirect exports ("requires transitive").
 
